/***************************************************************
 * Name:      drawing_canvas.h
 * Purpose:   For drawing music
 * Author:    John Conner Atkeson
 * Created:   2007-11-06
 * Copyright: John Conner Atkeson (http://jca3.freeshell.org)
 * License:   LGPL
 **************************************************************/
#ifndef drawing_canvas_h
#define drawing_canvas_h 1
// "No source file named"  "Breakpoint 1"  "pending";
// taskkill /F /IM fretless.exe
#include "wx_pch.h"
#include <wx/msgdlg.h>

//(*InternalHeaders(fretlessDialog)
#include <wx/bitmap.h>
#include <wx/font.h>
#include <wx/fontenum.h>
#include <wx/fontmap.h>
#include <wx/image.h>
#include <wx/intl.h>
#include <wx/settings.h>
#include <wx/string.h>
#include <wx/dcbuffer.h>
#include <wx/dcmemory.h>
#include "audio.h"

#define have_player 1
/* ************************************************************************************************************ */
class Box_Mapper_Class{
public:
  double realleft, realright, realwdt;
  double realtop, realbottom, realhgt;
  double scrleft, scrright, scrwdt;
  double scrtop, scrbottom, scrhgt;
  double x_ratio_to_screen, y_ratio_to_screen;
  //-------------------------------------------------------------------
  Box_Mapper_Class::Box_Mapper_Class();
  //-------------------------------------------------------------------
  void Set_Screen(double xleft, double xright, double ytop, double ybottom);
  //-------------------------------------------------------------------
  void Set_Real(double xleft, double xright, double ytop, double ybottom);
  //-------------------------------------------------------------------
  void set_ratios();
  //-------------------------------------------------------------------
  double Map_X_To_Screen(double xreal);
  //-------------------------------------------------------------------
  double Map_Y_To_Screen(double yreal);
  //-------------------------------------------------------------------
  double Map_X_To_Real(double xscr);
  //-------------------------------------------------------------------
  double Map_Y_To_Real(double yscr);
  //-------------------------------------------------------------------
  void Map_To_Screen(double xreal, double yreal, double *xscr, double *yscr);
  //-------------------------------------------------------------------
  void Map_To_Real(double xscr, double yscr, double *xreal, double *yreal);
};

class DrawingCanvasClass : public wxPanel{
public:
  bool left_mouse_down;
#if have_player
  Player_Class *player;
#endif
  wxPanel* DrawingPanel;
  wxWindow *m_parent;
  Voice_Track_Class *Voice_Track;
  // Splinewave_Generator_Class *sgen;
  Freewave_Generator_Class *sgen;
  Event_Marker_Class *selected_event;
  double altstart, loudness_start;
  class Box_Mapper_Class *Box_Map;
  DrawingCanvasClass::DrawingCanvasClass(wxWindow *parent, int id);
  /* ************************************************************************************************************ */
  DrawingCanvasClass::~DrawingCanvasClass();
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnShow(wxEvent& WXUNUSED(event))
  {
    // wxPaintDC dc(this);
    // Painter(dc);
    // wxMessageBox("Show event handled", _T("Shown"), wxOK | wxICON_INFORMATION, this);
  }
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::Painter(wxDC& dc);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnPaint(wxPaintEvent& event){
    wxPaintDC dc(this);
    Painter(dc);
  }/* DrawingCanvasClass::OnPaint */
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnSize(wxSizeEvent& event)
  {
    Refresh();
  }/* DrawingCanvasClass::OnSize */
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnDrawingPanelLeftDown(wxMouseEvent& event);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnDrawingPanelLeftUp(wxMouseEvent& event);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnDrawingPanelRightDown(wxMouseEvent& event);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnDrawingPanelRightUp(wxMouseEvent& event);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnDrawingPanelMouseMove(wxMouseEvent& event);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnQuit(wxCommandEvent& event)
  {
    Close();
  };
};/* DrawingCanvasClass */

class MyFrame: public wxFrame
{
public:

  MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size);

  void OnQuit(wxCommandEvent& event);
  void OnAbout(wxCommandEvent& event);

  DECLARE_EVENT_TABLE()
};
#endif// drawing_canvas_h

